import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener,KeyListener {
    Manager M;
    SelectColor CS;
    ListenSquare RESET;
    double[] a=new double[4];
    HorizontalSlider[] VAL=new HorizontalSlider[4];
    ControlPanelColor ORTHO,PSEUDO,POINT,EXTRA;
    ControlPanelSpecial DECOMP;
    ControlPanel FORMAT;
    Complex[] Z=new Complex[2];
    SelectInteger SOLID,SPEED;
    ListenSquare[] VIEW=new ListenSquare[31];
    ListenSquare EXPORT,PARTNER;
    Output OUT;
    Rotater R;
    SelectWord FILE;

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
         CS=new SelectColor(M,0,454,420,50);
	 RESET=new ListenSquare(0,120,125,22,null);
	 SOLID=new SelectInteger(330,220,50,25,7,0,7,1);
	 SPEED=new SelectInteger(330,140,50,25,3,0,7,1);
	 EXPORT=new ListenSquare(425,484,50,20);EXPORT.on=1;
	 PARTNER=new ListenSquare(480,335,100,20);PARTNER.on=0;
	 RESET.on=1;
	 initValues();
	 setPanels();
	 setViews();
	 FILE=new SelectWord(480,484,100,20,"file");
     }

    public void setViews() {
	VIEW[0]=new ListenSquare(130,255,100,50,null); //special views
	VIEW[1]=new ListenSquare(160,215,40,35,null); //start
	VIEW[2]=new ListenSquare(160,310,40,35,null);  //stop
	for(int i=0;i<3;++i) VIEW[i].on=1;
    }

    public void initValues() {
	 Z[0]=new Complex(-.75,0);
	 Z[1]=new Complex(0,1);
	 VAL[0]=new HorizontalSlider(0,00,420,25,200,new Color(255,0,0));
	 VAL[1]=new HorizontalSlider(0,30,420,25,300,new Color(255,0,0));
	 VAL[2]=new HorizontalSlider(0,60,420,25,100,new Color(255,0,0));
	 VAL[3]=new HorizontalSlider(0,90,420,25,420,new Color(200,0,255));
	 for(int i=0;i<4;++i) a[i]=VAL[i].getValue();
    }


    public void setPanels() {

       Color[] C0={new Color(80,120,255),Color.white,Color.white,Color.black,Color.white};

       String[] OrthoString={"O1 ABCD","O2 ABEF","O3 ADMK","O4 AFLK","orthoschemes"};
       Color[] OrthoColor={new Color(255,0,255),new Color(180,0,220),new Color(200,0,200),new Color(120,0,180)};
        int[] OrthoState={0,0,0,0};
        ORTHO=new ControlPanelColor(C0,OrthoString,OrthoState,4,OrthoColor);

	String[] PseudoString={"P1 ACDHI","P2 CDFHI","P3 FHIKL","P4 DEFHJ","P5 AEFHJ","P6 DHJKM","pseudoprisms"};
	Color[] PseudoColor={new Color(50,100,255),new Color(0,0,255),new Color(250,0,150),new Color(0,0,200),new Color(0,120,150),new Color(180,0,120)};
	int[] PseudoState={1,0,0,0,0,0};
        PSEUDO=new ControlPanelColor(C0,PseudoString,PseudoState,6,PseudoColor);

	String[] FormatString={".obj",".stl (1 file per polyhedron)",".stl (all polyhedra in 1 file)","file format"};
	int[] FormatState={1,0,0};
        FORMAT=new ControlPanel(C0,FormatString,FormatState,3);

	String[] ExtraString={"E1 HJKMNO","E2 DEFNO","E3 DFHO","E4 ADHJNO","E5 AFHI","E6 AHIJ","E7 EFKMNO","E8 FHKO","extras"};
	Color[] ExtraColor={new Color(255,180,0),new Color(255,100,0),new Color(250,0,0),new Color(210,0,0),new Color(140,0,0),new Color(0,210,0),new Color(0,160,0),new Color(0,100,0),new Color(100,0,0),new Color(200,0,100)};
	int[] ExtraState={0,0,0,0,0,0,0,0,0};
        EXTRA=new ControlPanelColor(C0,ExtraString,ExtraState,8,ExtraColor);

	String[] PointString={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","points"};
       Color[] PointColor=new Color[24];
       for(int i=0;i<20;++i) PointColor[i]=Color.white;
       PointColor[1]=Color.yellow;
       PointColor[6]=new Color(80,160,255);  
       for(int i=7;i<10;++i) PointColor[i]=new Color(255,150,0);
       for(int i=10;i<13;++i) PointColor[i]=new Color(255,0,0);
       for(int i=13;i<16;++i) PointColor[i]=new Color(0,200,0);
       int[] PointState={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
       POINT=new ControlPanelColor(C0,PointString,PointState,15,PointColor);

       String[] DecompString={"1","2","3","4","decomps"};
       Color[] DecompColor=new Color[24];
       for(int i=0;i<6;++i) DecompColor[i]=Color.white;
       int[] DecompState={0,0,0,0};
       DECOMP=new ControlPanelSpecial(C0,DecompString,DecompState,4);

       ORTHO.C[0]=new Color(250,0,250);
       EXTRA.C[0]=new Color(220,0,220);
       PSEUDO.C[0]=new Color(190,0,190);
       FORMAT.C[0]=new Color(0,200,0);
       DECOMP.C[0]=new Color(80,120,255);
       POINT.C[0]=new Color(0,200,200);
    }





   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(Color.blue);
      g.fillRect(0,0,getWidth(),getHeight()); 
      drawControlPanels(g);  
      drawProjectControl(g);
      drawViews(g);
      drawButtons(g);
      CS.render(g);
   }



    public void drawControlPanels(Graphics2D g) {
	g.setColor(new Color(0,0,160));
	g.fillRect(423,0,250,500);
      ORTHO.render(g,480,0,100);
      PSEUDO.render(g,480,220,100);
      EXTRA.render(g,480,80,100);
      POINT.render(g,425,86,50);
      DECOMP.render(g,425,0,50);  
      FORMAT.render(g,425,415,155);
      for(int i=0;i<4;++i) VAL[i].render(g);

    }

    public void drawButtons(Graphics2D g) {
	RESET.render(g,new Color(0,0,140));
      EXPORT.render(g,new Color(0,150,0));
      PARTNER.render2(g,new Color(190,0,190));
      g.setColor(Color.white);
      g.drawString("a good parameter choice",5,135);
      SOLID.render(g,Color.red,Color.white,Color.white); 
      SPEED.render(g,Color.red,Color.white,Color.white);  
      g.setColor(Color.white);
      g.drawString("transparency", 330,258);
      g.drawString("speed", 340,178);
      g.drawString("export", 430,500);
      g.drawString("partner pseudos", 485,350);
      Color C=new Color(0,220,0);
      FILE.render(g,C,Color.white,Color.black);
      
    }

    public void drawViews(Graphics2D g) {
       VIEW[0].render(g,new Color(0,100,200));
       g.setColor(Color.white);
       g.drawString("click here for",(int)(VIEW[0].x+10),(int)(VIEW[0].y+15));
       g.drawString("special",(int)(VIEW[0].x+10),(int)(VIEW[0].y+30));
       g.drawString("projections",(int)(VIEW[0].x+10),(int)(VIEW[0].y+45));

	int halt=0;
	try {halt=R.halt;}
	catch(Exception e) {}
	if(halt==0) {
	    VIEW[1].render(g,new Color(0,200,0));
	    g.setColor(Color.white);
	    g.drawString("start",(int)(VIEW[1].x+5),(int)(VIEW[1].y+13));
	    g.drawString("motion",(int)(VIEW[1].x+5),(int)(VIEW[1].y+30));
	}
	if(halt==1) {
	    VIEW[2].render(g,new Color(200,0,0));
	    g.drawString("stop",(int)(VIEW[2].x+5),(int)(VIEW[2].y+13));
	    g.drawString("motion",(int)(VIEW[2].x+5),(int)(VIEW[2].y+30));
	}

    }

    public void drawProjectControl(Graphics2D g) {
	g.setColor(new Color(0,0,50));
	g.fillOval(40,140,280,280);
	g.setColor(new Color(0,50,255));
	g.drawOval(75,175,210,210);
	g.drawLine(180,140,180,420);
	g.drawLine(40,280,320,280);

	GeneralPath gp=new GeneralPath();	
        double s=Math.sqrt(a[0]);
	double c=Math.sqrt(1-a[0]);
	float x1=(float)(180+140*s);
	float y1=(float)(280+140*c);
	float x2=(float)(180-140*s);
	float y2=(float)(280-140*c);
	gp.moveTo(x1,y1);
	gp.lineTo(x2,y2);

	float x3=(float)(180-140*c);
	float y3=(float)(280+140*s);
	float x4=(float)(180+140*c);
	float y4=(float)(280-140*s);
	gp.moveTo(x3,y3);
	gp.lineTo(x4,y4);
	g.draw(gp);



	g.setColor(Color.white);
	g.drawOval(40,140,280,280);
	g.setColor(Color.blue);
	g.fillOval(110,210,140,140);
	g.setColor(Color.white);
	g.drawOval(110,210,140,140);

	Complex z=new Complex(Z[0]);
	z.x=180+140*z.x;
	z.y=280+140*z.y;
	g.setColor(Color.white);
	g.fillOval((int)(z.x-3),(int)(z.y-3),6,6);
    }


    public void setProjection(Point X) {
	Complex z=new Complex(X.x,X.y);
	z.x=z.x-180;
	z.y=z.y-280;
	z.x=z.x/140.0;
	z.y=z.y/140.0;
	if((z.norm()>.5)&&(z.norm()<1)) {
                Z[0]=new Complex(z);
		try {R.z=new Complex(Z[0]);}
		catch(Exception e) {}
	}

	if(VIEW[0].inside(X)==1) {
	    double t=Z[0].norm();
	    double test1=Math.abs(t-.5);
	    double test2=Math.abs(t-.75);
	    double test3=Math.abs(t-1);
	    Z[0]=Z[0].unit();
	    double radius=1;
	    if((test1<=test2)&&(test1<=test3)) radius=.5;
	    if((test2<=test3)&&(test2<=test1)) radius=.75;
	    if((test3<=test1)&&(test3<=test2)) radius=1;

            double s=Math.sqrt(a[0]);
	    double c=Math.sqrt(1-a[0]);
	    Complex[] W=new Complex[8];
	    W[0]=new Complex(1,0);
	    W[1]=new Complex(-1,0);
	    W[2]=new Complex(0,1);
	    W[3]=new Complex(0,-1);
	    W[4]=new Complex(s,c);
	    W[5]=new Complex(-s,-c);
	    W[6]=new Complex(c,-s);
	    W[7]=new Complex(-c,s);

	    int test=-1;
	    double min=2;
	    for(int i=0;i<8;++i) {
		double d=Complex.dist(Z[0],W[i]);
		if(d<min) {
		    min=d;
		    test=i;
		}
	    }
	    Z[0]=new Complex(W[test]);
	    Z[0]=Complex.times(Z[0],new Complex(radius,0));
	}



    }

    public void clearSettings() {
	for(int i=0;i<4;++i) ORTHO.L[i].on=0;
	for(int i=0;i<6;++i) PSEUDO.L[i].on=0;
	for(int i=0;i<8;++i) EXTRA.L[i].on=0;
    }

    public void specialSettings(Point X) {
	int k=-1;


	if(DECOMP.L[0][0].inside(X)==1) {
	     clearSettings();
	    ORTHO.L[1].on=1;
	    PSEUDO.L[4].on=1;
            EXTRA.L[4].on=1;
            EXTRA.L[5].on=1;
	}


	if(DECOMP.L[0][1].inside(X)==1) {
	    clearSettings();
	    ORTHO.L[0].on=1;
            PSEUDO.L[0].on=1;
	    PSEUDO.L[1].on=1;
	    EXTRA.L[1].on=1;
	    EXTRA.L[2].on=1;
	    EXTRA.L[3].on=1;
	    EXTRA.L[5].on=1;
	}

	if(DECOMP.L[2][0].inside(X)==1) {  
            clearSettings();  
            PSEUDO.L[3].on=1; 
            EXTRA.L[0].on=1; 
            EXTRA.L[6].on=1; 
            EXTRA.L[7].on=1; 
	 }

	if(DECOMP.L[2][1].inside(X)==1) {  
            clearSettings();  
            PSEUDO.L[5].on=1; 
            EXTRA.L[1].on=1; 
            EXTRA.L[2].on=1; 
            EXTRA.L[6].on=1; 
            EXTRA.L[7].on=1; 
	 }

	if(DECOMP.L[1][0].inside(X)==1) {
	     clearSettings();
	    ORTHO.L[3].on=1; 
	 }

	if(DECOMP.L[1][1].inside(X)==1) {
	     clearSettings();
	    PSEUDO.L[2].on=1; 
	    EXTRA.L[4].on=1; 
	 }

	if(DECOMP.L[3][0].inside(X)==1) {
	     clearSettings();
	    ORTHO.L[2].on=1; 
	 }

	if(DECOMP.L[3][1].inside(X)==1) {
	     clearSettings();
	    EXTRA.L[0].on=1; 
	    EXTRA.L[3].on=1; 
	 }

    }
    
    public void startRotation(Point X) {
	if(VIEW[1].inside(X)==1) {
	    R=new Rotater(M);
            new Thread(R).start();
	}

	if(VIEW[2].inside(X)==1) {
	    try {R.halt=0;}
	    catch(Exception e) {}
	}
    }


    public void processPanels(Point X) {
	ORTHO.process(X,CS.C);
	PSEUDO.process(X,CS.C);
	EXTRA.process(X,CS.C);
	POINT.process(X,CS.C);
	DECOMP.switchMode(X);
	FORMAT.switchMode(X);
	if(PARTNER.inside(X)==1) PARTNER.on=1-PARTNER.on;
	if(EXPORT.inside(X)==1) doExport();
    }

    public void changeSpeed(Point X) {
	SPEED.modify(X);
	if(SPEED.isModified(X)==1) {  
            try {
              R.angle=Math.pow(.5,22-.5*M.C.SPEED.val);
	    }
	    catch(Exception e) {}
	}
    }

    public void setParameters(Point X) {
	for(int i=0;i<4;++i) {
	      VAL[i].configure(X);
	      a[i]=VAL[i].getValue();
	}
    }

    

    
    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	CS.process(e);
	if(RESET.inside(J.X)==1) initValues();
	processPanels(J.X);
	specialSettings(J.X);
	setProjection(J.X);
	SOLID.modify(J.X);
	changeSpeed(J.X);
	startRotation(J.X);
	FILE.activate(J.X);
	setParameters(J.X);
	repaint();
	M.P.repaint();
    }

    public void mousePressed(MouseEvent e) {
	MouseData J=MouseData.process(e);
	for(int i=0;i<4;++i) VAL[i].activate(J.X);
	repaint();
    }
    
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {}    
     public void mouseDragged(MouseEvent e) {
        MouseData J=MouseData.process(e);
        setProjection(J.X);
	setParameters(J.X);
	repaint();
	M.P.repaint();
     }
    

    public void keyPressed(KeyEvent e) {
    }

    public void keyTyped(KeyEvent e) {
      	FILE.modify(e);
       	repaint();
    }
    
    public void keyReleased(KeyEvent e) {
    }




    /****export system**/

    public void doExport() {
	int mode=FORMAT.mode;
	if(mode==0) doExportOBJ();
	if(mode==1) doExportSTL1();
	if(mode==2) doExportSTL2();
    }

    
    public void doExportSTL1() {
	Polyhedron[] LIST=getList();
	int count=LIST.length;
	for(int i=0;i<count;++i) {
	    Integer FNUM=new Integer(i);
	    String S="Export/"+FILE.S+FNUM.toString()+".stl";
   	    OUT=new Output(S);
	    OUT.writeln("solid piece"+FNUM.toString());
	    OUT=new Output(S);
	    OUT.writeSTL(LIST[i],i,true);
	}
    }

    public void doExportSTL2() {
	Polyhedron[] LIST=getList();
	int count=LIST.length;
	String S="Export/"+FILE.S+".stl";
   	OUT=new Output(S);
	OUT.writeln("solid piece");
	for(int i=0;i<count;++i) {
	    Integer FNUM=new Integer(i);
	    OUT.writeSTL(LIST[i],i,false);
	}
	OUT.writeln("endsolid");
    }




    public void doExportOBJ() {
	Polyhedron[] LIST=getList();
	int count=LIST.length;
	String S="Export/"+FILE.S+".obj";
	OUT=new Output(S);
	OUT.writeln("# This is an obj file");
	Integer K=new Integer(count);
	OUT.writeln("# This file contains "+K.toString()+" polyhedra.");
	OUT.writeln("");

	for(int i=0;i<count;++i) {
	    OUT.writeOBJ(LIST[i],i);
	    OUT.writeln("");
	}
	OUT.writeln("# end of file");
    }



    /**This gets the list of polyhedra*/
    
    public Polyhedron[] getList() {

   Polyhedron[] LIST=new Polyhedron[40];
   int count=0;
	for(int i=0;i<4;++i) {
	    if(ORTHO.L[i].on==1) {
		LIST[count]=PolyhedronData.PX(i,a);
		++count;
	    }
	}
	for(int i=0;i<6;++i) {
	    if(PSEUDO.L[i].on==1) {
		LIST[count]=PolyhedronData.PX(i+4,a);
		++count;
	    }
	}


	for(int i=0;i<8;++i) {
	    if(EXTRA.L[i].on==1) {
		LIST[count]=PolyhedronData.PX(i+10,a);	 
		++count;
	    }
	}
	Polyhedron[] LIST2=new Polyhedron[count];
	for(int i=0;i<count;++i) LIST2[i]=LIST[i];
	return LIST2;
    }



}

