import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class FaceOrdering {
    Polyhedron[] LIST=new Polyhedron[20];
    int length;
    Vector[] PROJ=new Vector[2];
    int[][] checked=new int[100][2];
    int count;

    public FaceOrdering() {}

    public FaceOrdering(Polyhedron[] LIST1,int length1,Vector[] PROJ1) {
	this.count=0;
	this.length=length1;
	for(int i=0;i<this.length;++i) {
	    this.LIST[i]=new Polyhedron(LIST1[i]);
	}
	this.PROJ[0]=new Vector(PROJ1[0]);
	this.PROJ[1]=new Vector(PROJ1[1]);
    }


    public void correctlyOrder() {
	int test=1;
	int count2=0;
	while((count2<40)&&(test!=0)) {
            test=testOrdering();
	    improve();
	    ++count2;
	}
    }

    public int testOrdering() {
	for(int i=0;i<length;++i) {
	    for(int j=i+1;j<length;++j) {
		int[] n={i,j};
		int test=PolyhedronFace.top(LIST[i],LIST[j],PROJ);
		if(test!=1) augmentList(n);
		if(test==1) return(1);
	    }
	}
	return(0);
    }


    public void improve() {

	for(int i =0;i<length;++i) {
	    for(int j=i+1;j<length;++j) {
		int[] n={i,j};
		  int test=isOnList(n);
		  if(test==0) {
		     test=PolyhedronFace.top(LIST[i],LIST[j],PROJ);
		     if(test!=1) augmentList(n);

		    if(test==1) {
		       Polyhedron P1=new Polyhedron(LIST[i]);
		       Polyhedron P2=new Polyhedron(LIST[j]);
		       LIST[i]=new Polyhedron(P2);
		       LIST[j]=new Polyhedron(P1);
		       modifyList(i,j);
		       i=length;
		       j=length;
		    }
		  }
	    }
	}
    }


    public void printOut() {
	System.out.println("list");
	for(int i=0;i<count;++i) {
	    System.out.println(checked[i][0]+" "+checked[i][1]);
	}
    }




    public void shortenList(int q,int n) {
	int count2=0;
	int[][] checked2=new int[100][2];
	for(int i=0;i<count;++i) {
	    if(n!=checked[i][q]) {
		checked2[i][0]=checked[i][0];
		checked2[i][1]=checked[i][1];
		++count2;
	    }
	}
	count=count2;
	for(int i=0;i<count;++i) {
	    checked[i][0]=checked2[i][0];
	    checked[i][1]=checked2[i][1];
	}

    }


    public void modifyList(int p,int q) {

	for(int i=0;i<count;++i) {
	    int temp0=checked[i][0];
	    int temp1=checked[i][1];
	    if(temp0==p) checked[i][0]=q;
	    if(temp0==q) checked[i][0]=p;
	    if(temp1==p) checked[i][1]=q;
	    if(temp1==q) checked[i][1]=p;
	}
    }


    public void augmentList(int[] n) {
	int test=isOnList(n);
	if(test==0) {
	    checked[count][0]=n[0];
	    checked[count][1]=n[1];
	    ++count;
	}
    }

    public int isOnList(int[] n) {
	for(int i=0;i<count;++i) {
	    if((n[0]==checked[i][0])&&(n[1]==checked[i][1])) return(1);
	}
	return(0);
    }


}

